#!/usr/local/bin/perl
#               -------------
#                   Links
#               -------------
#               Links Manager
#
#  File: report.cgi
#  Description: Let's a user report a dead link - script checks if the report being submitted is valid.
#  Original Author: Alex Krohn
#  Modified By : Paul Wilson
#  Email: pwilson@wiredon.net
#  Web: http://www.wiredon.net/
#  Version: 1.01
#
# (c) 1998 Gossamer Threads Inc. 
#
################################################################

@referers = ('www.yoururl.com/cgi-bin/report.cgi','yoururl.com/cgi-bin/report.cgi','http://www.yoururl.com/cgi-bin/report.cgi');

# SPECIFY ACCEPTED REFERERS ABOVE!!!!

################################################################

#   Setup Notes:
#       Make sure the require statement below points to the config file.    

# Required Librariers
# --------------------------------------------------------

eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

    require "admin/links.cfg";              # Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db_utils.pl";
    require "$db_lib_path/links.def";
    $build_use_templates ?
        require "$db_lib_path/site_html_templates.pl" :
        require "$db_lib_path/site_html.pl";
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
    exit;
}

# ========================================================

eval { &main; };                            # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 

sub main {
# --------------------------------------------------------
    local (%in) = &parse_form;
    
    if ($in{'report'}) {
        &report_it;
    }
    elsif ($in{$db_key} =~ /^\d+$/) {
        my (%rec) = &get_record ($in{$db_key});
        ($rec{$db_key} eq $in{$db_key}) ?
            &site_html_report_form    (%rec) :
            &site_html_report_failure_form ("Unkown Link ID: $in{$db_key}");
    }
    
}

sub report_it {
# --------------------------------------------------------          
    my $id    = $in{$db_key};
    my $serror = $in{'serror'};
    my $time = $in{'time'};
    my $remail = $in{'remail'};

# Check the referer.
    if (@referers) {
        $found = 0;
        foreach (@referers) {
            $ENV{'HTTP_REFERER'} =~ /$_/i and $found++ and last;
        }
        if (!$found) {
            &site_html_report_failure_form ("Auto submission is not allowed in this directory. Please visit the site to report a link.");
            return;
        }
    }



# Let's get the link information.
    my %rec = &get_record ($id);
    ($rec{$db_key} eq $id) or (&site_html_report_failure_form ("Unable to find link with ID '$id'.") and return);


     ($remail ne "") or (&site_html_report_failure_form ("Please enter your email address.") and return);

     &verify_link;
    
}


sub send_email {
# --------------------------------------------------------
# Sends an email to the admin, letting him know that there is
# a new link waiting to be validated. No error checking as we don't
# want users to see the informative &cgierr output. 

# Check to make sure that there is an admin email address defined.
    $db_admin_email or &cgierr("Admin Email Address Not Defined in config file!");

    my $id    = $in{$db_key};
    my $Title = $in{'Title'};
    my $URL = $in{'URL'};
    my $time = $in{'time'};
    my $remail = $in{'remail'};
    my $to      = $db_admin_email;
    my $from    = $in{$db_cols[$db_contact_email]};
    my $subject = "Deadlink Reported - $Title\n";
    my $msg     = qq|Hello Administrator,

The following link has been reported as dead by $remail:

         Resource ID:      $id
         Resource Title:   $Title
         Resource URL:    $URL
         Reporters Email: $remail
         Time:               $time

This link has been checked and seems but be dead but you may wish to double check it!

Sincerely,
Links Manager.
    |;

# Then mail it away!    
    require "$db_lib_path/Mailer.pm";
    my $mailer = new Mailer ( { smtp => $db_smtp_server, 
                                sendmail => $db_mail_path, 
                                from => $from, 
                                subject => $subject,
                                to => $to,
                                msg => $msg,
                                log => $db_mailer_log
                            } ) or return;
    $mailer->send or return;

    my $to2      = $remail;
    my $from2    = $in{$db_cols[$db_contact_email]};
    my $subject2 = "Deadlink Reported - $Title!\n";
    my $msg2     = qq|Hello,

The following link has been reported to the administrator as being dead:

         Resource ID:      $id
         Resource Title:   $Title
         Resource URL:    $URL
         Reporters Email: $remail
         Time:               $time

Thanks for helping make our directory user friendly!
  
Sincerely,
Links Manager.
    |;

# Then mail it away!    
    require "$db_lib_path/Mailer.pm";
    my $mailer = new Mailer ( { smtp => $db_smtp_server, 
                                sendmail => $db_mail_path, 
                                from => $from2, 
                                subject => $subject2,
                                to => $to2,
                                msg => $msg2,
                                log => $db_mailer_log
                            } ) or return;
    $mailer->send or return;
}


sub verify_link {
# -----------------------------------------------------
    $db_file_name = './admin/data/links.db';
    use strict;
    use vars qw(%urls %code %msg $method $db_url $db_key_pos $db_key $db_script_url $db_file_name %in);
    
    my $use_html = $ENV{'REQUEST_METHOD'};
    
    
# Try to init the Parallel User Checker.
    my ($checker, $slow, %ok_status, %fail_status, $status, $error);
    %ok_status = (
              200, "OK 200",
              201, "CREATED 201",
              202, "Accepted 202",
              203, "Partial Information 203",
              204, "No Response 204",
        );

    %fail_status = (
              -1,  "Could not lookup server",
              -2,  "Could not open socket",
              -3,  "Could not bind socket",
              -4,  "Could not connect",
              301, "Found, but moved",
              302, "Found, but data resides under different URL (add a /)",
              303, "Method",
              304, "Not Modified",
              400, "Bad request",
              401, "Unauthorized",
              402, "PaymentRequired",
              403, "Forbidden",
              404, "File Not found",
              500, "Internal Error",
              501, "Not implemented",
              502, "Service temporarily overloaded",
              503, "Gateway timeout ",
              600, "Bad request",
              601, "Not implemented",
              602, "Connection failed (host not found?)",
              603, "Timed out",
    );      

# Go through and register all the URL's.   
   
        if (($in{'URL'} =~ /^http/) or ($in{'URL'} =~ /^ftp/)) {
            my $id  = $in{'ID'};
            my $url = $in{'URL'};       
            ($status, $error) = &check_link ($url);
            $urls{$url} = $id;
            if (exists $ok_status{$status}) {
     &site_html_report_failure_form ("The status of this link in $status ($ok_status{$status}), therefore you cannot report it!") and return;            
            }
            else {
                $error =~ s/\n//g;
                $code{$url} = $status || 'unresolvable';
                $msg{$url}  = $fail_status{$status} || $error;
                if (exists $fail_status{$status}) {
                &logit;
                &send_email; 
                &site_html_report_success_form;  
                }
                else {
                   &logit;
                   &send_email;
                   &site_html_report_success_form;             
                }
            }
            
        }


}


sub logit {

my $id = $in{'ID'};
my $title = $in{'Title'};
my $url = $in{'URL'};
my $Email = $in{'Email'};
my $Desc = $in{'Desc'};
my $date = &get_date;

open (ID, "<$db_report_db") or &cgierr("Unable to open id file: $db_report_id. Reason: $!");
@data=<ID>;
close ID;

foreach $line (@data) {
chomp $line;
($theid,$thetitle,$theurl,$thedesc,$theemail,$thedate) = split(/\|/, $line);
if ($id eq $theid) {
&site_html_report_failure_form ("The link ($in{'Title'}) has already been reported, you cannot report it again.") and exit;
}
}

open (ID, "<$db_report_id") or &cgierr("Unable to open id file: $db_report_id. Reason: $!");
        $newid = <ID> + 1;                
        close ID;

# Update the counter.
        open (ID, ">$db_report_id") or &cgierr("Unable to open id file: $db_report_id. Reason: $!");
            flock(ID, 2) unless (!$db_use_flock);
            print ID $newid;     # update counter.
            close ID;           

open (VAL, ">>$db_report_db") or &cgierr("Unable to open validate file: $db_report_db. Reason: $!");
            flock(VAL, 2) unless (!$db_use_flock);       
            print VAL "$id|$title|$url|$Desc|$Email|$date\n";    
            close VAL;      # automatically removes file lock

}
    

sub check_link {
# -----------------------------------------------------
# Check links without LWP.
#
    my ($url) = shift;
    my ($host, $port, $path, $sock, $line);
    my $cr = "\015\012";

    ($url =~ m,^http://([^:/]+):?(\d*)(.*),i) and (($host, $port, $path) = ($1, $2, $3));
    $path ||= '/';
    $port ||= 80;
    $path =~ s/#.*//;

    $host or return undef, "Can't parse host from url: $url";
    use IO::Socket;
    $sock = new IO::Socket::INET ( PeerAddr => $host,
                                   PeerPort => 80,
                                   Proto    => 'tcp',
                                   Type     => SOCK_STREAM,
                                   ) or return undef, $@;
    $sock->autoflush(1);
    $sock->timeout(5);
    print $sock "GET $path HTTP/1.0$cr";
    print $sock "Host: $host$cr";
    print $sock "User-Agent: Links 2.0 (http://gossamer-threads.com/scripts/links/)$cr$cr";
    my $response = <$sock>;
    ($protocol, $status) = split / /, $response;
    close $sock;
   
    return $status;
}  

