#!/usr/local/bin/perl
#               -------------
#                   Links
#               -------------
#               Links Manager
#
#  File: reported.cgi
#  Description: View the reported links in your admin area.
#  Original Author: Alex Krohn
#  Modified By : Paul Wilson
#  Email: pwilson@wiredon.net
#  Web: http://www.wiredon.net/
#  Version: 1.01
#
# (c) 1998 Gossamer Threads Inc. 
#
# =====================================================================
#
#   Setup Notes:
#       Make sure the require statement below points to the config file.    

# Required Librariers
# --------------------------------------------------------

eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

    require "links.cfg";              # Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db_utils.pl";
    require "$db_lib_path/links.def";
    $build_use_templates ?
        require "$db_lib_path/site_html_templates.pl" :
        require "$db_lib_path/site_html.pl";
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
    exit;
}

# ========================================================

eval { &main; };                            # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr.

if ($ENV{'REQUEST_METHOD'} eq 'GET') {
$buffer = $ENV{'QUERY_STRING'};
} 
else {
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
}

# Break em up into a format the script can read

@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
($name, $value) = split(/=/, $pair);
$value =~ tr/+/ /;
$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
$FORM{$name} = $value;
}

$action = $FORM{action};

if ($action eq "delete") { 
&delete(); 
}  

sub main {
# --------------------------------------------------------

open (DB, "<$db_report_db") or &cgierr("Unable to open db file: $db_report_db. Reason: $!");
        @data = <DB>;                
        close DB;

print "Content-type: text/html\n\n";
print "<font size=4 face=verdana><b>Deadlinks Reported:</b></font>";

foreach $line (@data) {
chomp $line;
($theid,$thetitle,$theurl,$thedesc,$theemail,$thedate) = split(/\|/, $line);
print "<table>";
print "<tr><td>ID: </td><td>$theid</td></tr>";
print "<tr><td>Title: </td><td><a href=$theurl>$thetitle</a></td></tr>";
print "<tr><td>URL: </td><td><a href=$theurl>$theurl</a></td></tr>";
print "<tr><td>Description: </td><td>$thedesc</a></td></tr>";
print "<tr><td>Email: </td><td><a href=mailto:$theemail>$theemail</a></td></tr>";
print "<tr><td><b>Reported</b>: </td><td>$thedate</a></td></tr>";
print "</table><br><br>";
}


}

